# About
MC-FairGen is a task set generator for multi-core dual-criticality systems. MC-FairGen is used to create mixed-criticality task sets in a fair manner. The main problem with existing task set generators is that they do not consider all possible combinations of utilization bound value for LO-mode and HI-mode. MC-Fairgen considers all such possible combinations.

The source code contains the following files:
1. taskparam.py - contains task set parameters and options to configure them such as utilization step, distribution etc.
2. mrand.py - Python version of MRandFixedSum algorithm [2]
3. taskgen.py - Actual implementation of the task set generator. Contains routine to generate mixed-criticality tasks and writing task sets to a file.


# Quick Start
To get started, download the copy of the source code.

Ensure your system supports the following software requisites.
**Software Requisites**
1. Python 2.7 (Python 3 is not supported at this moment)
2. Numpy 1.8.2

MC-FairGen is a python library. To generate task sets run "python taskgen.py" in the python shell. The generated task set files are present under /data/in/ folder.
The source code is written for Linux (Ubuntu) machine. If you are using Windows, please update the path parameters in the taskparam.py file accordingly.


# Limitations
The current version of the generator only supports dual-criticality task sets. The generator is still in the development stage and can be improved further to support multiple configurations. Any improvements and fixes are welcome.

The generator can easily be configured for various user constraints on the task set parameters. Hope the documentation of the code helps in configuration.


# References
For more details please refer to
[1] **MC-FairGen Generator**  Saravanan Ramanathan and Arvind Easwaran, “Evaluation of Mixed-Criticality Scheduling Algorithms using a Fair Taskset Generator”, in International Workshop on Analysis Tools and Methodologies for Embedded and Real-time Systems (WATERS), July 2016.

[2] **MRandFixedSum Algorithm and Log-uniform period distribution** E. Paul, S. Roger, and D. Robert I., “Techniques for the synthesis of multiprocessor tasksets,” in 1st International Workshop on Analysis Tools and Methodologies for Embedded and Real-time Systems (WATERS), July 2010.


# Contributions
Please contact [Saravanan Ramanathan](saravana016@e.ntu.edu.sg) for any issues.
